<!--
  ~ (c) Copyright 2024 Swiss Post Ltd.
  -->

<ng-container *ngIf="mixAndDownloadStatus$ | async as mixAndDownloadStatus">
	<h1 class="h2 fw-medium mb-3">
		{{ 'mixAndDownload.title' | translate }}
	</h1>
	<p class="mb-4">
		{{ 'mixAndDownload.instruction' | translate }}
	</p>

	<section *ngIf="exportableBallotBoxes.size" class="mb-5">
		<sdm-page-actions [forceReady]="!!mixableBallotBoxes.size" #pageActionsComponent>
			<ng-container onReady>
				<i aria-hidden="true" class="bi bi-info-circle"></i>
				<p [innerHTML]="'mixAndDownload.exportSection.fullExportNotReady' | translate:{count: exportableBallotBoxes.size, total: (mixableBallotBoxes.size + exportableBallotBoxes.size)}">
				</p>
				<ng-container [ngTemplateOutlet]="exportTemporary"></ng-container>
			</ng-container>

			<ng-container onError>
				<i aria-hidden="true" class="bi bi-exclamation-circle"></i>
				<p *ngIf="pageActionsComponent.hasErrorFeedback">
					{{ 'error.' + pageActionsComponent.errorFeedbackCode | translate }}
				</p>
				<p *ngIf="!pageActionsComponent.hasErrorFeedback">
					{{ 'mixAndDownload.exportSection.error' | translate }}
				</p>
				<ng-container [ngTemplateOutlet]="exportTemporary"></ng-container>
			</ng-container>

			<ng-template #exportTemporary>
				<button (click)="export()" class="btn btn-link" type="button" [disabled]="mixAndDownloadStatus === WorkflowStatus.InProgress">
					<i aria-hidden="true" class="bi bi-upload"></i>
					{{ 'mixAndDownload.exportSection.exportTemporary' | translate }}
				</button>
			</ng-template>

			<ng-container onComplete>
				<i aria-hidden="true" class="bi bi-check-circle"></i>
				<p id="exportable-ballot-box-list-desc">
					{{ 'mixAndDownload.exportSection.fullExportReady' | translate }}
				</p>
				<button (click)="export()" [ngClass]="isFullExportDone ? 'btn-link' : 'btn-primary'" class="btn" type="button">
					{{ 'mixAndDownload.exportSection.export' | translate }}
					<i aria-hidden="true" class="bi bi-upload"></i>
				</button>
			</ng-container>
		</sdm-page-actions>



		<sdm-ballot-box-list
				[ballotBoxes]="exportableBallotBoxes"
				[describedById]="'exportable-ballot-box-list-desc'"
		></sdm-ballot-box-list>
	</section>

	<section *ngIf="mixableBallotBoxes.size">
		<sdm-page-actions>

			<ng-container onReady>
				<i aria-hidden="true" class="bi bi-shuffle"></i>
				<p id="mixable-ballot-box-list-desc">
					{{ 'mixAndDownload.uploadedBoxesSection.mixAndDownloadReady' | translate }}
				</p>
				<ng-container [ngTemplateOutlet]="mixDownloadButton"></ng-container>
			</ng-container>
			<ng-container onError>
				<i aria-hidden="true" class="bi bi-shuffle"></i>
				<p id="mixable-ballot-box-list-err">
					{{ 'mixAndDownload.uploadedBoxesSection.error' | translate }}
				</p>
				<ng-container [ngTemplateOutlet]="mixDownloadButton"></ng-container>
			</ng-container>
			<ng-container onProgress>
				<div class="spinner">
					<span aria-hidden="true" class="spinner-border"></span>
					<span class="visually-hidden" role="status">{{ 'common.loading' | translate }}</span>
				</div>
				<p>{{ 'mixAndDownload.uploadedBoxesSection.mixAndDownloadInProgress' | translate }}</p>
			</ng-container>

			<ng-template #mixDownloadButton>
				<button (click)="openModal(confirmation)" [disabled]="!hasSelection" class="btn btn-primary" type="button">
					<i aria-hidden="true" class="bi bi-play-circle"></i>
					{{ 'mixAndDownload.uploadedBoxesSection.mixAndDownload' | translate }}
				</button>
			</ng-template>
		</sdm-page-actions>

		<sdm-ballot-box-list
				(ballotBoxesSelected)="selectedBallotBoxes = $event"
				[ballotBoxes]="mixableBallotBoxes"
				[describedById]="'mixable-ballot-box-list-desc'"
				[enableCheckbox]="mixAndDownloadStatus !== WorkflowStatus.InProgress"
		></sdm-ballot-box-list>
	</section>
</ng-container>

<ng-template #confirmation let-modal>
	<div class="modal-header">
		<h1 class="modal-title h4" id="confirmation-modal-title">
			{{ 'mixAndDownload.confirmation.title' | translate }}
		</h1>
	</div>
	<div class="modal-body">
		<p>
			{{ 'mixAndDownload.confirmation.body' | translate }}
		</p>
		<ul class="mt-2">
			<li *ngFor="let bbox of selectedBallotBoxes">
				{{bbox.defaultTitle}}
			</li>
		</ul>
	</div>
	<div class="modal-footer">
		<button
				(click)="modal.close(false)"
				class="btn btn-outline-primary"
				type="button"
		>
			{{ 'common.cancel' | translate }}
		</button>
		<button (click)="modal.close(true)" class="btn btn-primary" type="button">
			{{ 'common.confirm' | translate }}
		</button>
	</div>
</ng-template>
